# Calendar.pm 
#	Copyright(C)2001 Ktat, All rights reserved.

package Calendar;

use strict;

sub new {
	my $pkg  = shift;
	my $year = shift;
	my $month= shift;
	$year = 1970	if !defined($year);
	$month= 1		if !defined($month);
	bless {
		month=> $month,
		days => Days($year,$month),
		fday => First_day($year,$month)
	},$pkg;
}


sub First_day{
	# Thanks for http://www.din.or.jp/~ohzaki/perl.htm
	my $year = shift;
	my $month= shift;
	if ($month == 1 or $month == 2) {
		$year--;
		$month += 12;
	}
	int($year + int($year / 4) - int($year / 100) + int($year / 400) + int((13 * $month + 8) / 5) + 1) % 7;
}

sub Days{
	# Thanks for http://www.din.or.jp/~ohzaki/perl.htm
	my $year = shift;
	my $month= shift;
	my @days = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	my $lastday = $days[$month - 1] + ($month == 2 and $year % 4 == 0 and ($year % 400 == 0 or $year % 100 != 0));
	return $lastday;
}

sub calc{
	my $self 	= shift;
	my $day 	= shift;
	my $_day 	= $self->{fday};
	my $i = 1;
	$_day += ($day-1) % 7;
	$_day -=7	if $_day > 6;
	return $_day;
}

sub search{
	require "day_info.pl";
	my $self 	= shift;
	my $day 	= shift;
	my $month   = $self->{month};
	my $date  =$month.substr("0".$day,-2);
	my $w_date="*".substr("0".$day,-2);
	my $fday = $self->calc($day);
	my($rest,$mrest) = day_info::info();
	my @word = ();
	my $sday = "normal";
	my $week = $day >= 29 ? 4 : int(($day - 1) / 7);
	++$week;
	if(exists $rest->{$month.substr("0".($day-1),-2)} and $self->calc(($day-1)) == 0){
		$rest->{$date} = "x"	if !exists $rest->{$date};
		push(@word,$rest->{$date});
		$sday = "rest2";
	}
	if(exists $mrest->{"$month-$week-$fday"} or exists $mrest->{"*-$week-$fday"} or exists $mrest->{"*-*-$fday"}){
		push(@word, exists $mrest->{"*-*-$fday"} ? $mrest->{"*-*-$fday"} : exists $mrest->{"*-$week-$fday"} ? $mrest->{"*-$week-$fday"} : $mrest->{"$month-$week-$fday"});
		$sday = "rest2";
	}
	if(exists $rest->{$date}){
		push(@word,$rest->{$date});
		$sday = "rest2";
	}
	{
		my %word;
		foreach my $word (@word){
			$word{$word}++	if $word;
		}
		@word = keys %word;
	}
	return ($sday,\@word)
}

1;

__END__
